#include"FC2722.h"
#include"uart.h"

#define  UART_TXD_H  FP15=1
#define  UART_TXD_L  FP15=0

#define  P_UART_RXD  FP14

struct STRUCT_UART struct_uart={0,0,0,0,0};
/******************************************************************************************************
*      : void uart_send_10_bits(void)
*      ܣģ⴮ڷͳ              1000  ʼλ1  Ϊ8 ֹͣλ1 żУ
*  ڲ   
*  ڲ
*      ڣ2020.11.23
*      ߣм
******************************************************************************************************/
void uart_send_10_bits(void)
{
  static uint8_t dat=0;
   
  if(struct_uart.bitUartTxdEnable)
  {  
    switch(struct_uart.u8txdStep)
    {
      case 0:
        dat=struct_uart.u8UartTxdBuf[0];
        struct_uart.u8txdBufPtr=0;
        struct_uart.u8txdStep=1;
      break;
	    
      case 1:
        UART_TXD_L;//ʼλ
        struct_uart.u8txdStep=2;
      break;
    
      case 2:
      case 3:
      case 4:
      case 5:
      case 6:
      case 7:
      case 8:  
      case 9:        
        if(dat&0x01)
        {
          UART_TXD_H;  
        }
        else
        {
          UART_TXD_L;  
        }
        dat>>=1;
        struct_uart.u8txdStep++;
      break;
    
      case 10:
        UART_TXD_H; 
        struct_uart.u8txdBufPtr++;
        if(struct_uart.u8txdBufPtr==struct_uart.u8txdCount)
        {
          struct_uart.bitUartTxdEnable=0;//ϣر
          return;
        }         
        dat=struct_uart.u8UartTxdBuf[struct_uart.u8txdBufPtr];        
        struct_uart.u8txdStep=1;          
      break;   
    }
  }
  else if(struct_uart.bitStartBitEnable)
  {
 //   struct_uart.bitStartBitEnable=0;
 //   UART_TXD_L;
  }
  else
  {
    UART_TXD_H;    
  }  
}

/******************************************************************************************************
*      : void uart_recive_10_bits(void)
*      ܣģ⴮ڽճ  ʱֻһֽ      Ͷ˵ĲʱΪ1000  250usһ 
*  ڲ   
*  ڲ
*      ڣ2020.11.23
*      ߣм
******************************************************************************************************/
void uart_recive_10_bits(void)
{
  static uint8_t dat=0;
   
  switch(struct_uart.u8rxdStep)
  {
    case 0:
 	   //͵ƽʱ2*0.25ms
    if(P_UART_RXD==0)
    {
	  struct_uart.u8cnt++;
	  if(struct_uart.u8cnt>3)
      {
        dat=0;
	    struct_uart.u8cnt=0;
        struct_uart.u8rxdBufPtr=0;  
        struct_uart.u8UartRxdBuf[0]=0;	
        struct_uart.u8rxdCount=0;		 
		struct_uart.u8rxdStep=1;        
	  }   
    }
	else
	{
      struct_uart.u8cnt=0;
    }     
    break;
    
 
    case 1:  
	struct_uart.u8cnt++;      
	if(struct_uart.u8cnt>1)
	{ 
	   struct_uart.u8cnt=0;
       dat>>=1;
       if(P_UART_RXD)
	   dat|=0x80;       
       struct_uart.u8rxdCount=1;
       struct_uart.u8rxdStep=2;
     }
     break;

	 case 2:
	 struct_uart.u8cnt++;      
	 if(struct_uart.u8cnt>3)
	 {  
	   struct_uart.u8cnt=0;
       dat>>=1;
       if(P_UART_RXD)
	   dat|=0x80;       
	   struct_uart.u8rxdCount++;
	   if(struct_uart.u8rxdCount>7)
	   {		  
         struct_uart.u8UartRxdBuf[0]=dat;
         struct_uart.u8rxdStep=0; 
		 struct_uart.bitUartRxdFinish=1;  
	   }
     }
	 break;  
  }   
}
