ifndef __SN8P2233__INC__H
SN8P2233__INC__H equ 1
	R	EQU	0x82
	Z	EQU	0x83
	Y	EQU	0x84
	PFLAG	EQU	0x86
		FZ	EQU	PFLAG.0
		FDC	EQU	PFLAG.1
		FC	EQU	PFLAG.2
		FNPD	EQU	PFLAG.6
		FNT0	EQU	PFLAG.7
	RBANK	EQU	0x87
		FRBNKS0	EQU	RBANK.0
		FRBNKS1	EQU	RBANK.1
	UDA	EQU	0x90
		FUDE	EQU	UDA.7
		FUDA6	EQU	UDA.6
		FUDA5	EQU	UDA.5
		FUDA4	EQU	UDA.4
		FUDA3	EQU	UDA.3
		FUDA2	EQU	UDA.2
		FUDA1	EQU	UDA.1
		FUDA0	EQU	UDA.0
	USTATUS	EQU	0x91
		FSOF	EQU	USTATUS.5
		FBUS_RST	EQU	USTATUS.4
		FSUSPEND	EQU	USTATUS.3
		FEP0SETUP	EQU	USTATUS.2
		FEP0IN	EQU	USTATUS.1
		FEP0OUT	EQU	USTATUS.0
	EP0OUT_CNT	EQU	0x92
		FUEP0OC4	EQU	EP0OUT_CNT.4
		FUEP0OC3	EQU	EP0OUT_CNT.3
		FUEP0OC2	EQU	EP0OUT_CNT.2
		FUEP0OC1	EQU	EP0OUT_CNT.1
		FUEP0OC0	EQU	EP0OUT_CNT.0
	USB_INT_EN	EQU	0x93
		FREG_EN	EQU	USB_INT_EN.7
		FDP_PU_EN	EQU	USB_INT_EN.6
		FSOF_INT_EN	EQU	USB_INT_EN.5
		FEP2NAK_INT_EN	EQU	USB_INT_EN.1
		FEP1NAK_INT_EN	EQU	USB_INT_EN.0
	EP_ACK	EQU	0x94
		FEP6_OUT	EQU	EP_ACK.5
		FEP5_IN	EQU	EP_ACK.4
		FEP2_ACK	EQU	EP_ACK.1
		FEP1_ACK	EQU	EP_ACK.0
	EP_NAK	EQU	0x95
		FEP2_NAK	EQU	EP_NAK.1
		FEP1_NAK	EQU	EP_NAK.0
	UE0R	EQU	0x96
		FUE0M1	EQU	UE0R.6
		FUE0M0	EQU	UE0R.5
		FUE0C3	EQU	UE0R.3
		FUE0C2	EQU	UE0R.2
		FUE0C1	EQU	UE0R.1
		FUE0C0	EQU	UE0R.0
	UE1R	EQU	0x97
		FUE1E	EQU	UE1R.7
		FUE1M1	EQU	UE1R.6
		FUE1M0	EQU	UE1R.5
		FUE1C4	EQU	UE1R.4
		FUE1C3	EQU	UE1R.3
		FUE1C2	EQU	UE1R.2
		FUE1C1	EQU	UE1R.1
		FUE1C0	EQU	UE1R.0
	UE2R	EQU	0x98
		FUE2E	EQU	UE2R.7
		FUE2M1	EQU	UE2R.6
		FUE2M0	EQU	UE2R.5
		FUE2C4	EQU	UE2R.4
		FUE2C3	EQU	UE2R.3
		FUE2C2	EQU	UE2R.2
		FUE2C1	EQU	UE2R.1
		FUE2C0	EQU	UE2R.0
	UE3R	EQU	0x99
		FUE3E	EQU	UE3R.7
		FUE3M1	EQU	UE3R.6
		FUE3M0	EQU	UE3R.5
		FUE3C3	EQU	UE3R.3
		FUE3C2	EQU	UE3R.2
		FUE3C1	EQU	UE3R.1
		FUE3C0	EQU	UE3R.0
	UE4R	EQU	0x9a
		FUE4E	EQU	UE4R.7
		FUE4M1	EQU	UE4R.6
		FUE4M0	EQU	UE4R.5
		FUE4C3	EQU	UE4R.3
		FUE4C2	EQU	UE4R.2
		FUE4C1	EQU	UE4R.1
		FUE4C0	EQU	UE4R.0
	UEER	EQU	0x9b
		FUE6E	EQU	UEER.1
		FUE5E	EQU	UEER.0
	EP5IN_CNT	EQU	0x9c
		FEP5IN_CNT_5	EQU	EP5IN_CNT.5
		FEP5IN_CNT_4	EQU	EP5IN_CNT.4
		FEP5IN_CNT_3	EQU	EP5IN_CNT.3
		FEP5IN_CNT_2	EQU	EP5IN_CNT.2
		FEP5IN_CNT_1	EQU	EP5IN_CNT.1
		FEP5IN_CNT_0	EQU	EP5IN_CNT.0
	EP6OUT_CNT_L	EQU	0x9e
		FEP6OUT_CNT_7	EQU	EP6OUT_CNT_L.7
		FEP6OUT_CNT_6	EQU	EP6OUT_CNT_L.6
		FEP6OUT_CNT_5	EQU	EP6OUT_CNT_L.5
		FEP6OUT_CNT_4	EQU	EP6OUT_CNT_L.4
		FEP6OUT_CNT_3	EQU	EP6OUT_CNT_L.3
		FEP6OUT_CNT_2	EQU	EP6OUT_CNT_L.2
		FEP6OUT_CNT_1	EQU	EP6OUT_CNT_L.1
		FEP6OUT_CNT_0	EQU	EP6OUT_CNT_L.0
	EP6OUT_CNT_H	EQU	0x9f
		FEP6OUT_CNT_8	EQU	EP6OUT_CNT_H.0
	UDP0_L	EQU	0xa3
		FUDP07	EQU	UDP0_L.7
		FUDP06	EQU	UDP0_L.6
		FUDP05	EQU	UDP0_L.5
		FUDP04	EQU	UDP0_L.4
		FUDP03	EQU	UDP0_L.3
		FUDP02	EQU	UDP0_L.2
		FUDP01	EQU	UDP0_L.1
		FUDP00	EQU	UDP0_L.0
	UDP0_H	EQU	0xa4
		FWE0	EQU	UDP0_H.7
		FRE0	EQU	UDP0_H.6
		FUDP08	EQU	UDP0_H.0
	UDR0_R	EQU	0xa5
		FUDR0_R7	EQU	UDR0_R.7
		FUDR0_R6	EQU	UDR0_R.6
		FUDR0_R5	EQU	UDR0_R.5
		FUDR0_R4	EQU	UDR0_R.4
		FUDR0_R3	EQU	UDR0_R.3
		FUDR0_R2	EQU	UDR0_R.2
		FUDR0_R1	EQU	UDR0_R.1
		FUDR0_R0	EQU	UDR0_R.0
	UDR0_W	EQU	0xa6
		FUDR0_W7	EQU	UDR0_W.7
		FUDR0_W6	EQU	UDR0_W.6
		FUDR0_W5	EQU	UDR0_W.5
		FUDR0_W4	EQU	UDR0_W.4
		FUDR0_W3	EQU	UDR0_W.3
		FUDR0_W2	EQU	UDR0_W.2
		FUDR0_W1	EQU	UDR0_W.1
		FUDR0_W0	EQU	UDR0_W.0
	EP1OUT_CNT	EQU	0xa7
		FUEP1OC4	EQU	EP1OUT_CNT.4
		FUEP1OC3	EQU	EP1OUT_CNT.3
		FUEP1OC2	EQU	EP1OUT_CNT.2
		FUEP1OC1	EQU	EP1OUT_CNT.1
		FUEP1OC0	EQU	EP1OUT_CNT.0
	EP2OUT_CNT	EQU	0xa8
		FUEP2OC4	EQU	EP2OUT_CNT.4
		FUEP2OC3	EQU	EP2OUT_CNT.3
		FUEP2OC2	EQU	EP2OUT_CNT.2
		FUEP2OC1	EQU	EP2OUT_CNT.1
		FUEP2OC0	EQU	EP2OUT_CNT.0
	EP3OUT_CNT	EQU	0xa9
		FUEP3OC3	EQU	EP3OUT_CNT.3
		FUEP3OC2	EQU	EP3OUT_CNT.2
		FUEP3OC1	EQU	EP3OUT_CNT.1
		FUEP3OC0	EQU	EP3OUT_CNT.0
	EP4OUT_CNT	EQU	0xaa
		FUEP4OC3	EQU	EP4OUT_CNT.3
		FUEP4OC2	EQU	EP4OUT_CNT.2
		FUEP4OC1	EQU	EP4OUT_CNT.1
		FUEP4OC0	EQU	EP4OUT_CNT.0
	UPID	EQU	0xab
		FUBDE	EQU	UPID.2
		FDDP	EQU	UPID.1
		FDDN	EQU	UPID.0
	SIOM	EQU	0xb4
		FSENB	EQU	SIOM.7
		FSTART	EQU	SIOM.6
		FSRATE1	EQU	SIOM.5
		FSRATE0	EQU	SIOM.4
		FMLSB	EQU	SIOM.3
		FSCKMD	EQU	SIOM.2
		FSEDGE	EQU	SIOM.1
		FSP	EQU	SIOM.0
	SIOR	EQU	0xb5
	SIOB	EQU	0xb6
	P0M	EQU	0xb8
		FP04M	EQU	P0M.4
		FP03M	EQU	P0M.3
		FP02M	EQU	P0M.2
		FP01M	EQU	P0M.1
		FP00M	EQU	P0M.0
	PEDGE	EQU	0xbf
		FP00G1	EQU	PEDGE.4
		FP00G0	EQU	PEDGE.3
		FP01G1	EQU	PEDGE.2
		FP01G0	EQU	PEDGE.1
	P1W	EQU	0xc0
		FP17W	EQU	P1W.7
		FP16W	EQU	P1W.6
		FP15W	EQU	P1W.5
		FP14W	EQU	P1W.4
		FP13W	EQU	P1W.3
		FP12W	EQU	P1W.2
		FP11W	EQU	P1W.1
		FP10W	EQU	P1W.0
	P1M	EQU	0xc1
		FP17M	EQU	P1M.7
		FP16M	EQU	P1M.6
		FP15M	EQU	P1M.5
		FP14M	EQU	P1M.4
		FP13M	EQU	P1M.3
		FP12M	EQU	P1M.2
		FP11M	EQU	P1M.1
		FP10M	EQU	P1M.0
	P2M	EQU	0xc2
		FP25M	EQU	P2M.5
		FP24M	EQU	P2M.4
		FP23M	EQU	P2M.3
		FP22M	EQU	P2M.2
		FP21M	EQU	P2M.1
		FP20M	EQU	P2M.0
	P3M	EQU	0xc3
		FP37M	EQU	P3M.7
		FP36M	EQU	P3M.6
		FP35M	EQU	P3M.5
		FP34M	EQU	P3M.4
		FP33M	EQU	P3M.3
		FP32M	EQU	P3M.2
		FP31M	EQU	P3M.1
		FP30M	EQU	P3M.0
	P5M	EQU	0xc5
		FP52M	EQU	P5M.2
		FP51M	EQU	P5M.1
		FP50M	EQU	P5M.0
	INTRQ	EQU	0xc8
		FSOFIRQ	EQU	INTRQ.7
		FUSBIRQ	EQU	INTRQ.6
		FT1IRQ	EQU	INTRQ.5
		FT0IRQ	EQU	INTRQ.4
		FSIOIRQ	EQU	INTRQ.3
		FWAKEIRQ	EQU	INTRQ.2
		FP01IRQ	EQU	INTRQ.1
		FP00IRQ	EQU	INTRQ.0
	INTEN	EQU	0xc9
		FSOFIEN	EQU	INTEN.7
		FUSBIEN	EQU	INTEN.6
		FT1IEN	EQU	INTEN.5
		FT0IEN	EQU	INTEN.4
		FSIOIEN	EQU	INTEN.3
		FWAKEIEN	EQU	INTEN.2
		FP01IEN	EQU	INTEN.1
		FP00IEN	EQU	INTEN.0
	OSCM	EQU	0xca
		FCPUM1	EQU	OSCM.4
		FCPUM0	EQU	OSCM.3
		FCLKMD	EQU	OSCM.2
		FSTPHX	EQU	OSCM.1
	WDTR	EQU	0xcc
	PCL	EQU	0xce
	PCH	EQU	0xcf
	P0	EQU	0xd0
		FP05	EQU	P0.5
		FP04	EQU	P0.4
		FP03	EQU	P0.3
		FP02	EQU	P0.2
		FP01	EQU	P0.1
		FP00	EQU	P0.0
	P1	EQU	0xd1
		FP17	EQU	P1.7
		FP16	EQU	P1.6
		FP15	EQU	P1.5
		FP14	EQU	P1.4
		FP13	EQU	P1.3
		FP12	EQU	P1.2
		FP11	EQU	P1.1
		FP10	EQU	P1.0
	P2	EQU	0xd2
		FP25	EQU	P2.5
		FP24	EQU	P2.4
		FP23	EQU	P2.3
		FP22	EQU	P2.2
		FP21	EQU	P2.1
		FP20	EQU	P2.0
	P3	EQU	0xd3
		FP37	EQU	P3.7
		FP36	EQU	P3.6
		FP35	EQU	P3.5
		FP34	EQU	P3.4
		FP33	EQU	P3.3
		FP32	EQU	P3.2
		FP31	EQU	P3.1
		FP30	EQU	P3.0
	P5	EQU	0xd5
		FP52	EQU	P5.2
		FP51	EQU	P5.1
		FP50	EQU	P5.0
	T0M	EQU	0xd8
		FT0ENB	EQU	T0M.7
		FT0RATE2	EQU	T0M.6
		FT0RATE1	EQU	T0M.5
		FT0RATE0	EQU	T0M.4
	T0C	EQU	0xd9
	T1M	EQU	0xda
		FT1ENB	EQU	T1M.7
		FT1RATE2	EQU	T1M.6
		FT1RATE1	EQU	T1M.5
		FT1RATE0	EQU	T1M.4
	T1C_L	EQU	0xdb
		FT1C7	EQU	T1C_L.7
		FT1C6	EQU	T1C_L.6
		FT1C5	EQU	T1C_L.5
		FT1C4	EQU	T1C_L.4
		FT1C3	EQU	T1C_L.3
		FT1C2	EQU	T1C_L.2
		FT1C1	EQU	T1C_L.1
		FT1C0	EQU	T1C_L.0
	T1C_H	EQU	0xdc
		FT1C15	EQU	T1C_H.7
		FT1C14	EQU	T1C_H.6
		FT1C13	EQU	T1C_H.5
		FT1C12	EQU	T1C_H.4
		FT1C11	EQU	T1C_H.3
		FT1C10	EQU	T1C_H.2
		FT1C9	EQU	T1C_H.1
		FT1C8	EQU	T1C_H.0
	TKCON	EQU	0x88
	TKTMD0	EQU	0x89
	TKTMD1	EQU	0x8a
	TKTCH	EQU	0x8b
	TKTCL	EQU	0x8c
	TKTMRH	EQU	0x8d
	TKTMRL	EQU	0x8e
	TKMIO	EQU	0x8f
	SPIC1	EQU	0x99
	SPIBUF	EQU	0x9a
	lcdseg	EQU	0x9d
	TM1M	EQU	0xa0
	TM1CL	EQU	0xa1
	TM1CH	EQU	0xa2
	I2CADD	EQU	0xa9
	I2CBUF	EQU	0xaa
	E2PDB	EQU	0xac
	E2PADL	EQU	0xad
	E2PADH	EQU	0xae
	TM2M	EQU	0xb0
	TM2CL	EQU	0xb1
	TM2CH	EQU	0xb2
	TM2D0L	EQU	0xb3
	PWM2E	EQU	0xb7
	ADM	EQU	0xb9
	ADB	EQU	0xba
	ADR	EQU	0xbb
	ADT	EQU	0xbc
	VREFH	EQU	0xbd
	ADPCON	EQU	0xbe
	P2W	EQU	0xdd
	P3W	EQU	0xde
	RCADJ	EQU	0xcb
	INTRQ1	EQU	0xc6
	INTEN1	EQU	0xc7
	STKP	EQU	0xdf
		FGIE	EQU	STKP.7
		FSTKPB2	EQU	STKP.2
		FSTKPB1	EQU	STKP.1
		FSTKPB0	EQU	STKP.0
	P0UR	EQU	0xe0
		FP04R	EQU	P0UR.4
		FP03R	EQU	P0UR.3
		FP02R	EQU	P0UR.2
		FP01R	EQU	P0UR.1
		FP00R	EQU	P0UR.0
	P1UR	EQU	0xe1
	P2UR	EQU	0xe2
		FP25R	EQU	P2UR.5
		FP24R	EQU	P2UR.4
		FP23R	EQU	P2UR.3
		FP22R	EQU	P2UR.2
		FP21R	EQU	P2UR.1
		FP20R	EQU	P2UR.0
	P3UR	EQU	0xe3
	P5UR	EQU	0xe5
		FP52R	EQU	P5UR.2
		FP51R	EQU	P5UR.1
		FP50R	EQU	P5UR.0
	@YZ	EQU	0xe7
	P1OC	EQU	0xe9
		FP52OC	EQU	P1OC.3
		FP50OC	EQU	P1OC.2
		FP11OC	EQU	P1OC.1
		FP10OC	EQU	P1OC.0
	STK7L	EQU	0xf0
	STK7H	EQU	0xf1
		FS7PC12	EQU	STK7H.4
		FS7PC11	EQU	STK7H.3
		FS7PC10	EQU	STK7H.2
		FS7PC9	EQU	STK7H.1
		FS7PC8	EQU	STK7H.0
	STK6L	EQU	0xf2
	STK6H	EQU	0xf3
		FS6PC12	EQU	STK6H.4
		FS6PC11	EQU	STK6H.3
		FS6PC10	EQU	STK6H.2
		FS6PC9	EQU	STK6H.1
		FS6PC8	EQU	STK6H.0
	STK5L	EQU	0xf4
	STK5H	EQU	0xf5
		FS5PC12	EQU	STK5H.4
		FS5PC11	EQU	STK5H.3
		FS5PC10	EQU	STK5H.2
		FS5PC9	EQU	STK5H.1
		FS5PC8	EQU	STK5H.0
	STK4L	EQU	0xf6
	STK4H	EQU	0xf7
		FS4PC12	EQU	STK4H.4
		FS4PC11	EQU	STK4H.3
		FS4PC10	EQU	STK4H.2
		FS4PC9	EQU	STK4H.1
		FS4PC8	EQU	STK4H.0
	STK3L	EQU	0xf8
	STK3H	EQU	0xf9
		FS3PC12	EQU	STK3H.4
		FS3PC11	EQU	STK3H.3
		FS3PC10	EQU	STK3H.2
		FS3PC9	EQU	STK3H.1
		FS3PC8	EQU	STK3H.0
	STK2L	EQU	0xfa
	STK2H	EQU	0xfb
		FS2PC12	EQU	STK2H.4
		FS2PC11	EQU	STK2H.3
		FS2PC10	EQU	STK2H.2
		FS2PC9	EQU	STK2H.1
		FS2PC8	EQU	STK2H.0
	STK1L	EQU	0xfc
	STK1H	EQU	0xfd
		FS1PC12	EQU	STK1H.4
		FS1PC11	EQU	STK1H.3
		FS1PC10	EQU	STK1H.2
		FS1PC9	EQU	STK1H.1
		FS1PC8	EQU	STK1H.0
	STK0L	EQU	0xfe
	STK0H	EQU	0xff
		FS0PC12	EQU	STK0H.4
		FS0PC11	EQU	STK0H.3
		FS0PC10	EQU	STK0H.2
		FS0PC9	EQU	STK0H.1
		FS0PC8	EQU	STK0H.0
@RST_WDT	macro
           MOV  A, #0x5A
           B0MOV  WDTR, A
    endm

SleepMode	macro          
           B0BSET      FCPUM0
    endm

GreenMode	macro          
           B0BSET      FCPUM1
           NOP
           NOP
    endm

SlowMode	macro          
           B0BSET      FCLKMD
           B0BSET      FSTPHX
    endm

Slow2Normal	macro          
           B0BCLR     FSTPHX
           NOP
           NOP
           NOP
           B0BCLR     FCLKMD
    endm

endif
