#include"FC2722.h"
#include"global.h"
#include"uart.h"
#include"key.h"
#include"tim.h"
struct LED_STRUCT ledStruct={1,1,1};
void scan_led(void);
void led_ctr(void);
void system_init(void);
/******************************************************************************************************
*      ƣvoid scan_led(void)
*      ܣ
*  ڲ
*  ڲ
*      
*      ڣ20201119
*      ߣм
******************************************************************************************************/
void scan_led(void)
{
  if(struct_uart.bitUartRxdFinish)
  {
    struct_uart.bitUartRxdFinish=0;
    ledStruct.u8ledFlag=struct_uart.u8UartRxdBuf[0];    
  }
  if(ledStruct.u8ledFlag&0x01)
  LED1_EN;  
  else
  LED1_DIS;  
  if(ledStruct.u8ledFlag&0x02)
  LED2_EN;  
  else
  LED2_DIS;   
  if(ledStruct.u8ledFlag&0x04)
  LED3_EN;  
  else
  LED3_DIS;   
  if(ledStruct.u8ledFlag&0x08)
  LED4_EN;  
  else
  LED4_DIS;             

  if(ledStruct.u8ledFlag&0x10)
  LED5_EN;  
  else
  LED5_DIS;  
  if(ledStruct.u8ledFlag&0x20)
  LED6_EN;  
  else
  LED6_DIS;   
  if(ledStruct.u8ledFlag&0x40)
  LED7_EN;  
  else
  LED7_DIS;   
  if(ledStruct.u8ledFlag&0x80)
  LED8_EN;  
  else
  LED8_DIS;      
}  
/******************************************************************************************************
*      ƣvoid system_init(void)
*      ܣϵͳʼ
*  ڲ
*  ڲ
*      ڣ2017.11.18
*      ߣм
******************************************************************************************************/
void system_init(void)
{
  P1=0x00;		//0000 0000
  P1M=0xEF;	    //1111 1111 ;0=in / 1=out
  P1UR=0x10;	//0000 0000 ;UP_pull;0=dis / 1=en
  P1W=0x00;		//0000 0000	;wakeup ;0=dis / 1=en

  P2=0x00;		//0000 0000
  P2M=0xFF;	    //1111 1011 ;0=in / 1=out
  P2UR=0x00;	//0000 0100 ;UP_pull;0=dis / 1=en
  P2W=0x00;		//0000 0000	;wakeup ;0=dis / 1=en

  P3=0x00;		//0000 0000
  P3M=0xFF;	    //1111 1111 ;0=in / 1=out
  P3UR=0x00;	//0000 0000 ;UP_pull;0=dis / 1=en
  P3W=0x00;		//0000 0000	;wakeup ;0=dis / 1=en

  FGIE=0u;
  INTEN=0x00u;	//0000 0000 /7-ADCIE  ;6-I2CIE  ;5-RPIE  ;4-TM2IE  ;3-TM1IE ;2-TM0IE ;1-INT1IE  ;0-INT0IE ;
  INTRQ=0x00u;	//0000 0000 /7-ADCIF  ;6-I2CIF  ;5-RPIF  ;4-TM2IF  ;3-TM1IF ;2-TM0IF ;1-INT1IF  ;0-INT0IF ;
  INTEN1=0x00u;	//0000 0000 /7-       ;6-       ;5-      ;4-OPAIE  ;3-T0IE  ;2-SPIIE ;1-TKTMRIE ;0-       ;
  INTRQ1=0x00u;	//0000 0000 /7-       ;6-       ;5-      ;4-OPAIF  ;3-T0IF  ;2-SPIIF ;1-TKTMRIF ;0-       ;

  PEDGE=0x00u;	//0000 0000 /7-INT1S2 ;6-INT1S1 ;5-INT1S0;4-INT1G1 ;3-INT1G0;2-INT0G1;1-INT0G0  ;0-INT0S  ;
  FGIE=0u;

  OPTION=0x10u;	//0001 0000 /7-RCADJEN;6-LIRC_EN;5-LDOEN ;4-LVDTEN ;3-RTCCON;2-WDTP2 ;1-WDTP1   ;0-WDTP0  ;

  T0M=0x00u;		//0000 ---- /7-T0TR   ;6-T0PS2  ;5-T0PS1 ;4-T0PS0  ;3-      ;2-      ;1-        ;0-       ;
  T0C=0x00u;		//0000 0000
	//******************************************************************
	//TM0(16bit)
  TM0M=0x00u;		//0000 0000 /7-TM0TR  ;6-TM0PS2 ;5-TM0PS1;4-TM0PS0 ;3-TM0CKS1;2-TM0CKS0;1-ALOAD ;0-PWM00E ;
  TM0CL=0;	//0000 0000
  TM0CH=0x00u;	//0000 0000
  TM0D0L=0x00u;	//0000 0000
  TM0D0H=0x00u;	//0000 0000
  TM0D1L=0x00u;	//0000 0000
  TM0D1H=0x00u;	//0000 0000
  PWM0E=0x00u;	//0000 0000 /7-PWM03OE;6-PWM02OE;5-PWM01OE;4-PWM00OE;3-PWM0M ;2-PWM03E ;1-PWM02E;0-PWM01E ;
	//******************************************************************
	//TM1(8bit)
  TM1M=0x00;		//1111 0011	/7-TM1TR  ;6-TM1PS2 ;5-TM1PS1;4-TM1PS0 ;3-TM1CKS1;2-TM1CKS0;1-ALOAD ;0-PWM10E ;
  TM1C=0;	  	//0000 0000	/PWM10  ռձȼĴ
  TM1D0=0x00u;	//0000 0000
  TM1D1=0x00u;	//0000 0000
  TM1D2=0x00u;	//0000 0000
  TM1D3=0x00u;	//0000 0000
  PWM1E=0x00u;	//0000 0000	/7-PWM13OE;6-PWM12OE;5-PWM11OE;4-PWM10OE;3-PWM1M ;2-PWM13E ;1-PWM12E;0-PWM11E ;
	//******************************************************************
	//TM2(8bit)
  TM2M=0x00;		//1111 0011	/7-TM2TR  ;6-TM2PS2 ;5-TM2PS1;4-TM2PS0 ;3-TM2CKS1;2-TM2CKS0;1-ALOAD ;0-PWM20E ;
  TM2C=0;	  	//0010 0000	/PWM20  ռձȼĴ
  TM2D0=0x00u;	//0000 0000
  TM2D1=0x00u;	//0000 0000
  TM2D2=0x00u;	//0000 0000
  TM2D3=0x00u;	//0000 0000
  PWM2E=0x00u;	//0001 0000	/7-PWM23OE;6-PWM22OE;5-PWM21OE;4-PWM20OE;3-PWM2M ;2-PWM23E ;1-PWM22E;0-PWM21E ;
} 
